<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>Utils xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../../apidocs/org/eclipse/papyrus/designer/languages/cpp/cdt/texteditor/Utils.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*******************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2015 CEA LIST.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *     Ansgar Radermacher - ansgar.radermacher@cea.fr CEA LIST - initial API and implementation</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_javadoccomment"> *******************************************************************************/</em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.languages.cpp.cdt.texteditor;
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.common.extensionpoints.GenerationConstants;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Element;
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.NamedElement;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Package;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <em class="jxr_javadoccomment"> * Collection of utility operations that are used by the CDT editor.</em>
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/cpp/cdt/texteditor/Utils.html">Utils</a> {
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String nsSep = <span class="jxr_string">"::"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <em class="jxr_javadoccomment">	 * Decrease the indentation of a text block. This function is used during synchronization, since</em>
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <em class="jxr_javadoccomment">	 * the code within an opaque behavior is not indented, whereas the code of an operation within a</em>
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <em class="jxr_javadoccomment">	 * file is indented with a tab.</em>
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> String decreaseIndent(<strong class="jxr_keyword">char</strong>[] contents, <strong class="jxr_keyword">int</strong> start, <strong class="jxr_keyword">int</strong> end) {
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  		<strong class="jxr_keyword">return</strong> decreaseIndent(contents, start, end, 4);
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  	}
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  	
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <em class="jxr_javadoccomment">	 * Decrease the indentation of a text block. This function is used during synchronization, since</em>
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <em class="jxr_javadoccomment">	 * the code within an opaque behavior is not indented, whereas the code of an operation within a</em>
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <em class="jxr_javadoccomment">	 * file is indented with a tab.</em>
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> String decreaseIndent(<strong class="jxr_keyword">char</strong>[] contents, <strong class="jxr_keyword">int</strong> start, <strong class="jxr_keyword">int</strong> end, <strong class="jxr_keyword">int</strong> indentation) {
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  		String newBlock = <span class="jxr_string">""</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  		<strong class="jxr_keyword">boolean</strong> newLine = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  		<strong class="jxr_keyword">int</strong> consume = 0;
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  		<strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> i = start; i &lt; end; i++) {
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  			<strong class="jxr_keyword">char</strong> c = contents[i];
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  			<em class="jxr_comment">// consume either a tab or 4 spaces;</em>
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  			<strong class="jxr_keyword">if</strong> (newLine &amp;&amp; (c == '\t')) {
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  				consume = 1;
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  			}
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  			
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  			<strong class="jxr_keyword">if</strong> (newLine &amp;&amp; (c == ' ')) {
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  				consume = indentation;
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  			}
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  			<strong class="jxr_keyword">if</strong> (consume == 0 || c != ' ') {
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  				newBlock += c;
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  				consume = 0;
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  			} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (c == ' ') {
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  				consume--;
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  			} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  				consume = 0;
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  			}
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  			
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  			<strong class="jxr_keyword">if</strong> ((c == '\n') || (c == '\r')) {
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  				newLine = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  			} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  				newLine = false;
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  			}
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  		}
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  		<strong class="jxr_keyword">return</strong> newBlock;
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  	}
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  <em class="jxr_javadoccomment">	 * Get an element via its qualified name. Will find elements from the root</em>
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  <em class="jxr_javadoccomment">	 * model and elements in imported models. Also supports target model in</em>
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  <em class="jxr_javadoccomment">	 * which imports have been copied (while keeping the top-level name)</em>
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  <em class="jxr_javadoccomment">	 * @param root</em>
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  <em class="jxr_javadoccomment">	 * @param qualifiedName</em>
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> NamedElement getQualifiedElement(Package root,
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  			String qualifiedName) {
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  		NamedElement namedElement = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  		<strong class="jxr_keyword">int</strong> index = qualifiedName.indexOf(nsSep);
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  		<strong class="jxr_keyword">if</strong> (index != -1) {
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  			<em class="jxr_comment">// first try using a path without top element (since</em>
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  			<em class="jxr_comment">// getQualifiedElement is typically used for</em>
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  			<em class="jxr_comment">// imported elements)</em>
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  			String remainder = qualifiedName.substring(index + 2);
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  			namedElement = getQualifiedElement(root, remainder, qualifiedName);
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  		}
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  		<strong class="jxr_keyword">if</strong> (namedElement == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  			<em class="jxr_comment">// try with complete name as path name, but assume that the element</em>
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  			<em class="jxr_comment">// has been copied into the model,</em>
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  			<em class="jxr_comment">// i.e. qualifiedName is prefixed by model name</em>
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  			namedElement = getQualifiedElement(root, qualifiedName,
<a class="jxr_linenumber" name="L100" href="#L100">100</a> 					root.getName() + nsSep + qualifiedName);
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 		}
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 		<strong class="jxr_keyword">return</strong> namedElement;
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 	}
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L106" href="#L106">106</a> <em class="jxr_javadoccomment">	 * Retrieve an element via its qualified name within a package The segments</em>
<a class="jxr_linenumber" name="L107" href="#L107">107</a> <em class="jxr_javadoccomment">	 * of the package may be non unique due to imports</em>
<a class="jxr_linenumber" name="L108" href="#L108">108</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L109" href="#L109">109</a> <em class="jxr_javadoccomment">	 * @return the found element, if it exists</em>
<a class="jxr_linenumber" name="L110" href="#L110">110</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> NamedElement getQualifiedElement(Package root,
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 			String remainingPath, String qualifiedName) {
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 		<strong class="jxr_keyword">if</strong> (root == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 			<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L115" href="#L115">115</a> 		}
<a class="jxr_linenumber" name="L116" href="#L116">116</a> 		<strong class="jxr_keyword">if</strong> (!remainingPath.contains(nsSep)) {
<a class="jxr_linenumber" name="L117" href="#L117">117</a> 			<strong class="jxr_keyword">for</strong> (NamedElement candidate : root.getMembers()) {
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 				String name = candidate.getName();
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 				<strong class="jxr_keyword">if</strong> ((name != <strong class="jxr_keyword">null</strong>) &amp;&amp; name.equals(remainingPath)) {
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 					<strong class="jxr_keyword">if</strong> (candidate.getQualifiedName().equals(qualifiedName)) {
<a class="jxr_linenumber" name="L121" href="#L121">121</a> 						<strong class="jxr_keyword">return</strong> candidate;
<a class="jxr_linenumber" name="L122" href="#L122">122</a> 					}
<a class="jxr_linenumber" name="L123" href="#L123">123</a> 				}
<a class="jxr_linenumber" name="L124" href="#L124">124</a> 			}
<a class="jxr_linenumber" name="L125" href="#L125">125</a> 		} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L126" href="#L126">126</a> 			String segment = remainingPath.split(nsSep)[0];
<a class="jxr_linenumber" name="L127" href="#L127">127</a> 			String remainder = remainingPath.substring(segment.length() + 2);
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 			<strong class="jxr_keyword">for</strong> (Element element : root.getMembers()) {
<a class="jxr_linenumber" name="L129" href="#L129">129</a> 				<strong class="jxr_keyword">if</strong> (element instanceof Package) {
<a class="jxr_linenumber" name="L130" href="#L130">130</a> 					<strong class="jxr_keyword">if</strong> (((NamedElement) element).getName().equals(segment)) {
<a class="jxr_linenumber" name="L131" href="#L131">131</a> 						NamedElement foundElement = getQualifiedElement(
<a class="jxr_linenumber" name="L132" href="#L132">132</a> 								(Package) element, remainder, qualifiedName);
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 						<em class="jxr_comment">// return, if not found</em>
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 						<strong class="jxr_keyword">if</strong> (foundElement != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 							<strong class="jxr_keyword">return</strong> foundElement;
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 						}
<a class="jxr_linenumber" name="L137" href="#L137">137</a> 					}
<a class="jxr_linenumber" name="L138" href="#L138">138</a> 				}
<a class="jxr_linenumber" name="L139" href="#L139">139</a> 			}
<a class="jxr_linenumber" name="L140" href="#L140">140</a> 		}
<a class="jxr_linenumber" name="L141" href="#L141">141</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L142" href="#L142">142</a> 	}
<a class="jxr_linenumber" name="L143" href="#L143">143</a> 
<a class="jxr_linenumber" name="L144" href="#L144">144</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L145" href="#L145">145</a> <em class="jxr_javadoccomment">	 * return the top-level owner of an element. This function returns the same</em>
<a class="jxr_linenumber" name="L146" href="#L146">146</a> <em class="jxr_javadoccomment">	 * value as getModel, if the top-level element is a model. While this is the</em>
<a class="jxr_linenumber" name="L147" href="#L147">147</a> <em class="jxr_javadoccomment">	 * case for models, model libraries have a top-level package (not a model).</em>
<a class="jxr_linenumber" name="L148" href="#L148">148</a> <em class="jxr_javadoccomment">	 * In this case, getTop returns the top-level package whereas getModel would</em>
<a class="jxr_linenumber" name="L149" href="#L149">149</a> <em class="jxr_javadoccomment">	 * return null.</em>
<a class="jxr_linenumber" name="L150" href="#L150">150</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L151" href="#L151">151</a> <em class="jxr_javadoccomment">	 * @param element</em>
<a class="jxr_linenumber" name="L152" href="#L152">152</a> <em class="jxr_javadoccomment">	 * @return the top-level owning package</em>
<a class="jxr_linenumber" name="L153" href="#L153">153</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L154" href="#L154">154</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Package getTop(Element element) {
<a class="jxr_linenumber" name="L155" href="#L155">155</a> 		<strong class="jxr_keyword">while</strong> (element != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L156" href="#L156">156</a> 			Element owner = element.getOwner();
<a class="jxr_linenumber" name="L157" href="#L157">157</a> 			<strong class="jxr_keyword">if</strong> (owner == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L158" href="#L158">158</a> 				<strong class="jxr_keyword">if</strong> (element instanceof Package) {
<a class="jxr_linenumber" name="L159" href="#L159">159</a> 					<strong class="jxr_keyword">return</strong> (Package) element;
<a class="jxr_linenumber" name="L160" href="#L160">160</a> 				}
<a class="jxr_linenumber" name="L161" href="#L161">161</a> 			}
<a class="jxr_linenumber" name="L162" href="#L162">162</a> 			element = owner;
<a class="jxr_linenumber" name="L163" href="#L163">163</a> 		}
<a class="jxr_linenumber" name="L164" href="#L164">164</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L165" href="#L165">165</a> 	}
<a class="jxr_linenumber" name="L166" href="#L166">166</a> 	
<a class="jxr_linenumber" name="L167" href="#L167">167</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L168" href="#L168">168</a> <em class="jxr_javadoccomment">	 * Remove generated code from a body (everything between the GENERATED_START flag</em>
<a class="jxr_linenumber" name="L169" href="#L169">169</a> <em class="jxr_javadoccomment">	 * </em>
<a class="jxr_linenumber" name="L170" href="#L170">170</a> <em class="jxr_javadoccomment">	 * @param bodyStr</em>
<a class="jxr_linenumber" name="L171" href="#L171">171</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L172" href="#L172">172</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L173" href="#L173">173</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> String removeGenerated(String bodyStr) {
<a class="jxr_linenumber" name="L174" href="#L174">174</a> 		<strong class="jxr_keyword">for</strong> (;;) {
<a class="jxr_linenumber" name="L175" href="#L175">175</a> 			<strong class="jxr_keyword">int</strong> startPos = bodyStr.indexOf(GenerationConstants.GENERATED_START);
<a class="jxr_linenumber" name="L176" href="#L176">176</a> 			<strong class="jxr_keyword">if</strong> (startPos == -1) {
<a class="jxr_linenumber" name="L177" href="#L177">177</a> 				<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L178" href="#L178">178</a> 			}
<a class="jxr_linenumber" name="L179" href="#L179">179</a> 			<em class="jxr_comment">// search line break of previous line (if any)</em>
<a class="jxr_linenumber" name="L180" href="#L180">180</a> 			<strong class="jxr_keyword">while</strong> ((startPos &gt; 0) &amp;&amp; bodyStr.charAt(startPos) != '\r' &amp;&amp; bodyStr.charAt(startPos) != '\n') {
<a class="jxr_linenumber" name="L181" href="#L181">181</a> 				startPos--;
<a class="jxr_linenumber" name="L182" href="#L182">182</a> 			}
<a class="jxr_linenumber" name="L183" href="#L183">183</a> 			<strong class="jxr_keyword">int</strong> endPos = bodyStr.indexOf(GenerationConstants.GENERATED_END, startPos);
<a class="jxr_linenumber" name="L184" href="#L184">184</a> 			<strong class="jxr_keyword">if</strong> (endPos == -1) {
<a class="jxr_linenumber" name="L185" href="#L185">185</a> 				<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L186" href="#L186">186</a> 			}
<a class="jxr_linenumber" name="L187" href="#L187">187</a> 			endPos += GenerationConstants.GENERATED_END.length();
<a class="jxr_linenumber" name="L188" href="#L188">188</a> 			<em class="jxr_comment">// stop at first non white-space character after comment.</em>
<a class="jxr_linenumber" name="L189" href="#L189">189</a> 			<strong class="jxr_keyword">while</strong> ((endPos &lt; bodyStr.length()) &amp;&amp; Character.isWhitespace(bodyStr.charAt(endPos))) {
<a class="jxr_linenumber" name="L190" href="#L190">190</a> 				endPos++;
<a class="jxr_linenumber" name="L191" href="#L191">191</a> 			}
<a class="jxr_linenumber" name="L192" href="#L192">192</a> 			bodyStr = bodyStr.substring(0, startPos) + bodyStr.substring(endPos);
<a class="jxr_linenumber" name="L193" href="#L193">193</a> 		}
<a class="jxr_linenumber" name="L194" href="#L194">194</a> 		<strong class="jxr_keyword">return</strong> bodyStr;
<a class="jxr_linenumber" name="L195" href="#L195">195</a> 	}
<a class="jxr_linenumber" name="L196" href="#L196">196</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016&#x2013;2017 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
